SystemOrganization addCategory: #'SqueakEnh-SqueakersInfo'!

!Browser methodsFor: '*squeakenh-squeakersinfo-message functions' stamp: 'Samir Saidani 1/30/2004 03:02'!
shiftedMessageListMenu: aMenu 
	"Fill aMenu with the items appropriate when the shift key is held down"
	Smalltalk isMorphic
		ifTrue: [aMenu addStayUpItem].
	aMenu addList: #(#('method pane' #makeIsolatedCodePane) #('tile scriptor' #openSyntaxView) #('toggle diffing (D)' #toggleDiffing) #('implementors of sent messages' #browseAllMessages) #- #('local senders of...' #browseLocalSendersOfMessages) #('local implementors of...' #browseLocalImplementors) #- #('spawn sub-protocol' #spawnProtocol) #('spawn full protocol' #spawnFullProtocol) #- #('sample instance' #makeSampleInstance) #('inspect instances' #inspectInstances) #('inspect subinstances' #inspectSubInstances) ).
	self addExtraShiftedItemsTo: aMenu.
	aMenu addList: #(#- #('change category...' #changeCategory) ).
	self canShowMultipleMessageCategories
		ifTrue: [aMenu addList: #(#('show category (C)' #showHomeCategory) )].
	aMenu addList: #(#- #('change sets with this method' #findMethodInChangeSets) #('revert to previous version' #revertToPreviousVersion) #('remove from current change set' #removeFromCurrentChanges) #('revert & remove from changes' #revertAndForget) #('add to current change set' #adoptMessageInCurrentChangeset) #('copy up or copy down...' #copyUpOrCopyDown) #- #('fetch documentation' #fetchDocPane) #('info on author' #authorInfo) #('more...' #unshiftedYellowButtonActivity) ).
	^ aMenu! !

!SMSqueakMap methodsFor: '*squeakenh-squeakersinfo-queries' stamp: 'Samir Saidani 1/30/2004 01:54'!
accountWithInitials: anInitial 
	"Look up an account by name. Return nil if missing."
	^ accounts values
		detect: [:a | a initials = anInitial]
		ifNone: []! !

PackageInfo subclass: #SqueakersInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEnh-SqueakersInfo'!

!SqueakersInfo commentStamp: 'sam 6/16/2004 17:50' prior: 0!
In order to have some info of squeakers (required a connection to squeakmap)!

!SqueakersInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 1/31/2004 15:06'!
readmeText
^ 'Add in the method menu of the browser the possibility to have more
info on the author : email, complete name, url, description... if such
informations are available on SqueakMap. So SqueakMap is a
prerequisite. Try it by open a method menu then more... then info on
author.'
! !

!Utilities class methodsFor: '*squeakenh-squeakersinfo-identification' stamp: 'sam 12/9/2004 17:37'!
identifyAuthorForClass: aClass selector: aSelector 
	| timeStamp smAccount menu |
	menu := MenuMorph new.
	timeStamp := Utilities
				timeStampForMethod: (aClass compiledMethodAt: aSelector).
	timeStamp isEmpty
		ifTrue: [
			PopUpMenu inform: ' Sorry, no available information '. 
			^ self].
	"lazy initialization of SqueakMap accounts"
	SMSqueakMap default accounts.
	smAccount := SMSqueakMap default accountWithInitials: timeStamp substrings first.
	smAccount
		ifNil: [
			PopUpMenu inform: ' Sorry, no available information '. 
			^ self].
	menu title: ' ' , smAccount name , ' '.
	menu submorphs first setBalloonText: smAccount summary.
	menu
		add: smAccount email
		target: SMUtilities
		selector: #sendMail:
		argument: smAccount email.
	menu
		add: smAccount url
		target: Scamper
		selector: #openOnUrl:
		argument: smAccount url.
	menu popUpInWorld! !

!StringHolder methodsFor: '*squeakenh-squeakersinfo-message list menu' stamp: 'Samir Saidani 1/30/2004 03:09'!
authorInfo
	| class selector |
	(selector _ self selectedMessageName)
		ifNotNil: [class _ self selectedClassOrMetaClass.
			class
				ifNotNil: [Utilities identifyAuthorForClass: class selector: selector]]! !
